/*****************************************************
CVAVR V2.05
Chip type               : ATmega8
AVR Core Clock frequency: 8 MHz
Project                 : hf sw inverter
*****************************************************/
#include <mega8.h>

#define HL	    PORTD.5
#define HR	    PORTB.0
#define LL	    PORTB.3
#define LR	    PORTB.4
#define LLD	    DDRB.3
#define LRD	    DDRB.4

typedef unsigned char u8;
typedef unsigned int u16;
typedef unsigned long u32;



u8 a=0xff, cntfb;

void gpio_cfg()
{
PORTB=7;    DDRB=0xff;
PORTC=1<<5; DDRC=0xff-1;
PORTD=1<<5; DDRD=~(1<<7);
}

void t1_cfg()
{
 TCCR1A = 1<<COM1A1|1<<COM1B1|1<<COM1A0|1<<WGM10;
 TCCR1B = 1;
 OCR1A  = 0;
 OCR1B  = 0xff;
 TIMSK  = 1<<TOIE1;
}

void acmp_cfg()
{

}

interrupt [TIM1_OVF] void t1_ovf()
{
#define s_step 156
#define dtv 2
static bit d=1,ph=1;
static u8 mst=0xff, c=0;
u8 tmp_table;

static const u8 s_table [s_step/2]=
{0,5,10,15,20,25,31,36,41,46,51,56,61,66,71,76,81,86,91,96,100,
105,110,115,119,124,128,133,137,141,146,150,154,158,162,166,170,174,178,181,185,189,
192,195,199,202,205,208,211,214,217,219,222,225,227,229,232,234,236,238,240,241,243,
245,246,247,249,250,251,252,253,253,254,254,255,255,255,255};

tmp_table=((u16)s_table [c]*mst)>>9;
if(tmp_table>0xff/2){tmp_table=0xff/2;}

if(d)
 {
	if(tmp_table<0xff/2-dtv){OCR1AL=tmp_table;OCR1BL=0xff-tmp_table;}
	else                    {OCR1AL=0xff/2-dtv;OCR1BL=0xff/2+dtv;}
  
  if(c<s_step/2-1){c++;} else {d=0;}
 }
else
  {
	if(tmp_table<0xff/2-dtv){OCR1AL=tmp_table;OCR1BL=0xff-tmp_table;}
	else                    {OCR1AL=0xff/2-dtv;OCR1BL=0xff/2+dtv;}
  
  if(c){c--;}
	else
	{
     d=1; ph^=1;
	 if(ph){HL=LL=LLD=1;HR=LR=LRD=0; cntfb=1;mst=a;}
	 else  {HL=LL=LLD=0;HR=LR=LRD=1;}
	}
  }

}


void main()
{
 gpio_cfg();
 t1_cfg();
 acmp_cfg();

#asm("sei") 
 
while (1)
      {


      }
}
